=== debian/changelog ===
minetest5 (5.2.1-0) unstable; urgency=medium

  * New upstream version 5.1.2. This is sse build, for mmx use venenux:games0x
  * added -fpermissive to allow the optimizations on the new release
  * added libxxf86vm to build depends due non recursive in older debians
  * change all references to minetest5 path
  * added missing libnl-genl-3-dev with alternative on wheezy or squeeze
  * in control added a large line due OBS service is crap on depends (using rpm as real)
  * added spatialindex support

 -- PICCORO Lenz McKAY <mckaygerhard@gmail.com>  Fri, 19 Nov 2021 22:33:20 -0400

minetest4 (4.0.18-0) unstable; urgency=medium

  * New upstream version 0.4.18. This is sse build, for mmx use venenux:games0x
  * added -fpermissive to allow the optimizations on the new release
  * added libxxf86vm to build depends due non recursive in older debians
  * Drop luajit-2.1.patch. Fixed upstream.
  * alternate between python-imaging to python-pil for backporting (Closes: #866441)
  * change all references to minetest4 path
  * added missing libnl-genl-3-dev with alternative on wheezy or squeeze
  * in control added a large line due OBS service is crap on depends (using rpm as real)

 -- PICCORO Lenz McKAY <mckaygerhard@gmail.com>  Fri, 19 Nov 2021 22:33:20 -0400

minetest (0.4.16+repack-4) unstable; urgency=medium

  * Add luajit-2.1.patch and patch the FindLuaJIT cmake module to detect
    version 2.1. (Closes: #873324)

 -- Markus Koschany <apo@debian.org>  Sat, 26 Aug 2017 23:50:33 +0200

minetest (0.4.16+repack-3) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.1.0.
  * minetest-data: Switch from python-imaging to python-pil. (Closes: #866441)
  * Build with ENABLE_SYSTEM_GMP=1 and use Debian's system library of GMP.
    - Build-depend on libgmp-dev.
  * Make sure that we really use system libraries of jsoncpp and gmp.
    Remove embedded libs in dh_clean override.
  * Update minetest.conf and add all available configuration options for
    dedicated servers.
  * Install minetest-mapper.6 with minetest-data.manpages.
  * Install appdata file into canonical directory /usr/share/metainfo.
  * Switch priority from extra to optional.

 -- Markus Koschany <apo@debian.org>  Wed, 23 Aug 2017 19:01:11 +0200

minetest (0.4.16+repack-2) unstable; urgency=medium

  * Upload to unstable.
  * Drop dependency on fonts-liberation. It is no longer needed.
  * minetest-server: Enable the postgresql backend.
  * Remove overrides for dh_clean and dh_auto_clean and unneeded variables.
    The override for dh_auto_clean prevented that the automatic cleanup of CMAKE
    generated files took place.
  * Remove minetest-data.lintian-overrides and depend on fonts-croscore instead.
    Replace embedded croscore fonts with system fonts.
  * Declare compliance with Debian Policy 4.0.0.

 -- Markus Koschany <apo@debian.org>  Sun, 25 Jun 2017 18:52:38 +0200

minetest (0.4.16+repack-1) experimental; urgency=medium

  * New upstream version 0.4.16+repack. (Closes: #864060)
  * Drop i18n.patch. Fixed upstream.
  * Refresh rawlua.patch.
  * service files: Use the default KillSignal SIGTERM again which
    is supported by upstream now.
  * service files: Pipe all log messages to /dev/null to reduce the noise.
    Log messages are already logged to /var/log/minetest by default.
  * Drop deprecated minetest.menu file.
  * Install missing files and simplify the install files.
  * Drop the manpages files in favor of install files.
    Otherwise the dh_install --list-missing option will cause a build failure
    despite the fact that the manpages are installed via manpages files.
  * repack.sh: Also remove all jar files.
  * Don't convert the lowres minetest icon to xpm anymore and remove imagemagick
    from Build-Depends.
  * Add an lintian-override for duplicate font files because fonts-croscore was
    removed from Debian.
  * Update debian/copyright for new release.
  * Remove binary files in clean target which are not automatically cleaned
    when building minetest twice in a row.

 -- Markus Koschany <apo@debian.org>  Mon, 05 Jun 2017 14:42:59 +0200

minetest (0.4.15+repack2-1) unstable; urgency=medium

  * New upstream version 0.4.15+repack2.
  * Update repack.sh. Remove liberation fonts as well since we use Debian's
    system fonts anyway. (Closes: #851114)
  * d/copyright: Remove paragraph about liberation fonts.

 -- Markus Koschany <apo@debian.org>  Fri, 13 Jan 2017 22:07:54 +0100

minetest (0.4.15+repack-1) unstable; urgency=medium

  * New upstream version 0.4.15+repack.
  * Use DroidSansFallbackFull.ttf instead of just DroidSansFallback.ttf.
    (Closes: #849360)
  * Delete all license.txt files before installing them into the Debian
    packages. Debian has its own copyright file.
  * Update debian/copyright for new release.

 -- Markus Koschany <apo@debian.org>  Wed, 28 Dec 2016 02:13:28 +0100

minetest (0.4.14+repack-7) unstable; urgency=medium

  * d/rules: Create /usr/share/games/minetest to prevent a FTBFS.

 -- Markus Koschany <apo@debian.org>  Thu, 22 Dec 2016 00:37:37 +0100

minetest (0.4.14+repack-6) unstable; urgency=medium

  * Switch to compat level 10.
  * minetest-server: Depend on lsb-base (>= 3.0-6).
  * minetest-data: Depend on fonts-droid-fallback.
  * Replace DroidSansFallback.ttf with Debian's system font and use
    minetest-data.links instead of debian/rules for this.
  * Provide a manpage for minetest-mapper.

 -- Markus Koschany <apo@debian.org>  Wed, 21 Dec 2016 23:22:47 +0100

minetest (0.4.14+repack-5) unstable; urgency=medium

  * Set correct Breaks and Replaces relationship for minetest-data.
    Thanks to Andreas Beckmann for the report. (Closes: #829150)

 -- Markus Koschany <apo@debian.org>  Wed, 13 Jul 2016 17:15:58 +0200

minetest (0.4.14+repack-4) unstable; urgency=medium

  * Drop minetest-dbg because it was replaced by the automatic -dbgsym package.
  * Declare compliance with Debian Policy 3.9.8.

