=== debian/control ===
Source: minetest5
Section: games
Priority: optional
Maintainer: PICCORO Lenz McKAY <mckaygerhard@gmail.com>
Build-Depends: cmake, pkg-config, 
 debhelper (>= 10) | dh-systemd | dh-autoreconf, lsb-release,
 cron,
 gettext, doxygen,
 libbz2-dev,
 libcurl4-gnutls-dev, libnl-genl-3-dev | libnl-dev | libnl-3-dev, librtmp-dev, libidn11-dev, libncurses-dev | libncurses5-dev,
 libfreetype6-dev,
 libglu1-mesa-dev,
 libgmp3-dev | libgmp-dev,
 libirrlicht-dev (>= 1.7.0),
 libjpeg-dev,
 libjsoncpp-dev,
 libleveldb-dev,
 libluajit-5.1-dev [i386 amd64 kfreebsd-i386 armel armhf powerpc powerpcspe mips],
 liblua5.1-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libpq-dev,
 libspatialindex-dev,
 libsqlite3-dev,
 libvorbis-dev,
 libx11-dev,
 libxxf86vm-dev,
 postgresql-server-dev-all | libpq-dev,
 zlib1g-dev
Standards-Version: 4.1.4
Homepage: https://www.minetest.net/
Vcs-Git: https://salsa.debian.org/games-team/minetest.git
Vcs-Browser: https://salsa.debian.org/games-team/minetest

Package: minetest5
Architecture: any
Depends: minetest5-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: minetest5-game | minetest5-game-game
Description: Multiplayer infinite-world block sandbox (client with embebed server)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is a improved upgrade over 5.2 series due 5.X one superset and changed 
 the protocol of network.

Package: minetest5-server
Architecture: any
Depends: minetest5-data (= ${source:Version}), adduser, lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
Recommends: minetest5-game | minetest5-game-game
Description: Multiplayer infinite-world block sandbox (server only)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the minetest server package.
 This is a improved upgrade over 5.2 series due 5.X one superset and changed 
 the protocol of network.

Package: minetest5-data
Architecture: all
Depends: adduser,${misc:Depends}
Provides: minetest5-game, minetest5-game-minenux
Description: Multiplayer infinite-world block sandbox (data files)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.
 This is a improved upgrade over 5.2 series due 5.X one superset and changed 
 the protocol of network.
